# Rate limits, user limits and heartbeats

Websockets

**Connection & message limits:**

<table><thead><tr><th width="84.01959228515625"></th><th width="164.9609375">Max Connections</th><th width="202.1195068359375">Max Total Subscriptions</th><th>Max msgs to Hydromancer per minute</th><th>Orderbooks streamed</th></tr></thead><tbody><tr><td><strong>Starter</strong></td><td>50</td><td>500</td><td>300</td><td>5</td></tr><tr><td><strong>Growth</strong></td><td>500</td><td>5000</td><td>3000</td><td>10</td></tr><tr><td><strong>Scale</strong></td><td>1000</td><td>10000</td><td>6000</td><td>100</td></tr></tbody></table>

**Note**: every address passed in subscription logic counts as 1 subscription for ones where you can pass multiple (applicable to userFills, userOrderUpdates, userNonFundingLedgerEvents, userLeverageUpdates and userIsolatedMarginUpdates).

**Subscription type limits:**

|                                   | Starter                             | Growth                       | Scale                        |
| --------------------------------- | ----------------------------------- | ---------------------------- | ---------------------------- |
| **userFills**                     | unlimited per key                   | unlimited per key            | unlimited per key            |
| **builderFills**                  | 1 builder per key, add-ons possible | 3 builders, add-ons possible | 3 builders, add-ons possible |
| **liquidationFills**              | 1 sub per key                       | 2 subs per key               | 2 subs per key               |
| **allFills** - *add-on websocket* | 400$ per connection                 | 400$ per connection          | 400$ per connection          |
| **userOrderUpdates**              | unlimited per key                   | unlimited per key            | unlimited per key            |
| **builderOrderUpdates**           | 1 builder per key, add-ons possible | 3 builders, add-ons possible | 3 builders, add-ons possible |
| **userNonFundingLedgerEvents**    | unlimited per key                   | unlimited per key            | unlimited per key            |
| **allUserNonFundingLedgerEvents** | 1 sub per key                       | 2 subs per key               | 2 subs per key               |
| **allTwapStatusUpdates**          | 1 sub per key                       | 2 subs per key               | 2 subs per key               |
| **activeAssetCtx**                | unlimited per key                   | unlimited per key            | unlimited per key            |
| **setOracleUpdates**              | 100 subs per key                    | 100 subs per key             | 100 subs per key             |
| **l4BookUpdates**                 | 5 coins                             | 50 coins                     | 200 coins                    |
| **l2Book**                        | 5 coins                             | 25 coins                     | 100 coins                    |
| **l2BookDiff**                    | 5 coins                             | 50 coins                     | 200 coins                    |
| **bbo**                           | 10 coins                            | 50 coins                     | 200 coins                    |
| **candle**                        | 10 subs per key                     | 50 subs per key              | 100 subs per key             |
| **userLeverageUpdates**           | unlimited per key                   | unlimited per key            | unlimited per key            |
| **allLeverageUpdates**            | 1 sub per key                       | 2 subs per key               | 3 subs per key               |
| **userIsolatedMarginUpdates**     | unlimited per key                   | unlimited per key            | unlimited per key            |
| **allIsolatedMarginUpdates**      | 1 sub per key                       | 2 subs per key               | 3 subs per key               |
| **fundingRates**                  | 1 sub per key                       | 1 sub per key                | 1 sub per key                |
| **builderCompletedTrades**        | 1 builder per key, add-ons possible | 3 builders, add-ons possible | 3 builders, add-ons possible |
| **builderLiquidations**           | 1 builder per key, add-ons possible | 3 builders, add-ons possible | 3 builders, add-ons possible |

All-books add-ons (`l4BookUpdatesAll`, `l2BookDiffAll`, `l2BookAll`, `bboAll`) are separate permission-gated subscriptions. They are not counted as separate per-coin subscriptions.

**Heartbeat:**

* Ping interval: 60 seconds (respond with pong)


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.hydromancer.xyz/readme/websocket/rate-limits-user-limits-and-heartbeats.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
